#include <stdio.h>
#include <iostream>

struct FName {
	int istart ;
	char szName[13] ;
} ;

int main(int argc , char *argv[ ]){
	char szTmp[256] ;
	char szTcDat[256] ;
	
	if(argc != 2){
		printf("tcget TC.DAT\nortcget TC2.DAT") ;
		return -1;
	}
	
	strcpy(szTcDat , argv[1]) ;

	FILE *fp = fopen(szTcDat , "rb" ) ;
	if(!fp){
		fclose(fp) ;
		printf("File Not Found.\n") ;
	}
	printf("File %s Open.\n" , szTcDat) ;
	
	int n ;
	fread(&n , 4 , 1 , fp) ;
	printf("Head:%X\n" , n) ;
	
	FName FN[n] ;
	
	bool bloop = true ;
	int i = 0 ;

	while(bloop){
		fread(&FN[i].istart , 4 , 1 , fp) ;
		fread(FN[i].szName , 13 , 1 , fp) ;
		if(FN[i].szName[0] == '\0'){
			bloop = false ;
		}else{
//			printf("%s\n" , FN[i].szName) ;
			i++ ;
		}
	}
	
	n = i +1 ;
	
	for(i=0 ; i<n ; i++){
		if(FN[i].szName[0]== '\0'){
			break ;
		}
		FILE *ofp = fopen(FN[i].szName , "wb") ;
		if(!ofp){
			fclose(ofp) ;
			printf("File cannot open. : %s\n" , FN[i].szName) ;
		}else{
			int size = FN[i+1].istart - FN[i].istart ;
			char *buff = new char[size] ;
			fseek(fp , FN[i].istart , SEEK_SET) ;
			fread(buff , size , 1 , fp) ;
			fwrite(buff , size , 1 , ofp) ;
			fclose(ofp) ;
			delete [] buff ;
			printf("%s done.\n" , FN[i].szName) ;
		}
		
	}
	
	fclose(fp) ;
	printf("File %s Close.\n" , szTcDat) ;
}